package listFW.visitor;

import listFW.*;

/**
 * 
 */
public class ReverseList2<T> implements IListAlgo<T,IList<T>, IListFactory<?>>  {
  
  public IMTList<T> emptyCase(IMTList<? extends T> host, IListFactory<?> ... fac) {
    return ((IListFactory<T>)fac[0]).makeEmptyList();  // Generates "unchecked cast" warning
  }
  public INEList<T> nonEmptyCase(INEList<? extends T> host, IListFactory<?> ... fac) {
    final IListFactory<T> f = (IListFactory<T>)fac[0];
    return host.execute(new IListAlgo<T,INEList<T>, IList<T>>()  {
      public INEList<T> emptyCase(IMTList<? extends T> h,  IList<T> ... acc) {
        return (INEList<T>)acc[0];  // cast required because delegating to host reduces type safety
      }
      public INEList<T> nonEmptyCase(INEList<? extends T> h,  IList<T>... acc) {
        return h.getRest().execute(this, f.makeNEList(h.getFirst(), acc[0]));
      }
    },f.makeEmptyList());
  }
}
  
  
