package lrs.test;
import lrs.*;
import lrs.visitor.*;
import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class Test_LRS extends TestCase {
  
  /**
   * A test method.
   * (Replace "X" with a name describing the test.  You may write as
   * many "testSomething" methods in this class as you wish, and each
   * one will be called when running JUnit over this class.)
   */
  public void test_string() {
    LRStruct<String> lrs = new LRStruct<String>();
    
    assertEquals("()", "()", lrs.toString());    
    assertEquals("(a)", "(a)", lrs.insertFront("a").toString());
    assertEquals("(b a)", "(b a)", lrs.insertFront("b").toString()); 
    
    assertEquals("(c a)", "(c a)", lrs.setFirst("c").toString()); 
    
  }

  
  public void test_number() {
    LRStruct<Number> lrs = new LRStruct<Number>();
    
    assertEquals("()", "()", lrs.toString());    
    assertEquals("(5)", "(5)", lrs.insertFront(5).toString());
    assertEquals("(3.14 5)", "(3.14 5)", lrs.insertFront(3.14).toString()); 
    
    assertEquals("3.14+5", 8.14, lrs.execute(Sum.Singleton));
    
    assertEquals("(-1 5)", "(-1 5)", lrs.setFirst(-1).toString()); 
    
    LRStruct<Integer> lrs_int = new LRStruct<Integer>();
    
    lrs_int.insertFront(42);
    
    //lrs.setRest(lrs_int);
    
    
    
  }
  
}
